Global iniLines
Global iniCmd$[512]
Global iniParm$[512]
GetINI()

Global ScreenWidth=512	; ScreenWidth=FromINI(ScreenWidth,"Screen Width","Sheet Width")
Global ScreenHeight=512	; ScreenHeight=FromINI(ScreenHeight,"Screen Height","Sheet Height")
Global SpriteWidth=128	; SpriteWidth=FromINI(SpriteWidth,"Sprite Size","Size","Sprite Width","Width")
Global SpriteHeight=128	; SpriteHeight=FromINI(SpriteHeight,"Sprite Size","Size","Sprite Height","Height")

Global MaxTextures=25

SpriteWidth=ScreenWidth/4
SpriteHeight=ScreenHeight/4	' Limited so that it works right!!

Global Rescale=1
	Temp$=Upper$(FromINItxt$("","Rescale","Make"))
	If temp$="TRUE" Or temp$="LARGER" Or temp$="BIGGER" Or temp$="GROW" Then Rescale=2
	If temp$="SMALLER" Or temp$="SHRINK" Then Rescale=1
	
Global OutFilename$="Out"	;	OutFilename$=FromINItxt$(OutFilename$,"Filename","Save As","Output")
outfilename$=Replace(outfilename$,"/","_")
outfilename$=Replace(outfilename$,"\","_")
outfilename$=Replace(outfilename$,";","_")
outfilename$=Replace(outfilename$,":","_")
outfilename$=Replace(outfilename$,"*","_")
outfilename$=Replace(outfilename$,"?","_")
outfilename$=Replace(outfilename$,"!","_")
outfilename$=Replace(outfilename$,Chr$(34),"")

Global MaskColor=$FF00FF

Global GrassColor=Rand(0,360)
Global GroundColor=(GrassColor+180)+Rand(-40,40)
Global GrassTexture=Rand(0,MaxTextures)
Global GroundTexture=Rand(0,MaxTextures)
Global GrassType=Rand(0,2)
Global GrassThick#=Rnd(Float(SpriteHeight)*0.15,Float(SpriteHeight)*0.4)
Global BottomType=Rand(0,1)
Global TopType=Rand(0,1)
Global ShadowThick#=Rnd(Float(SpriteHeight)*0.05,Float(SpriteHeight)*0.15)
Global HighlightThick#=Rnd(Float(SpriteHeight)*0.05,Float(SpriteHeight)*0.15)
Global HighlightPower#=Rnd(2.0,4.0)
Global DarkenThick#=Rnd(Float(SpriteHeight)*0.05,Float(SpriteHeight)*0.15)
Global DarkenPower#=Rnd(2.0,4.0)
Global EdgeType=Rand(0,1)
Global EdgeDistance#=Rnd(0.15,0.4)

Global LeftFade#=Rnd(0.25,0.5)
Global RightFade#=Rnd(0.25,0.5)

Global DarkDepthGrass#=Rnd(0.5,0.8)
Global DarkDepthGround#=Rnd(0.5,0.8)
Global DarkDepth#=DarkDepthGrass

Global UseSubTexture=1
Global SubTexture=Rand(0,MaxTextures)

Global Psychedelia#=Rnd(0,360)

Global RandSeed=0
Global RandSeed2=0

Global SpritesX=Floor(ScreenWidth/SpriteWidth)
Global SpritesY=Floor(ScreenHeight/SpriteHeight)

Function GetIni()
	iniLines=0
If FileType("settings.ini")=1	
	DebugLog "Found ini file"
	quickin=ReadFile("settings.ini")
	lines=0
	Repeat
		intxt$=ReadLine(quickin)
		If Instr(intxt,"=")
			cmd$=iniLeft$(intxt)
			parm$=iniRight(intxt)
			cmd=Trim$(cmd$)
			cmd=Replace$(cmd," ","")
			cmd=Lower$(cmd)
			parm$=Trim$(parm$)
			
			iniLines=iniLines+1
			iniCmd[iniLines]=cmd$
			iniParm[iniLines]=parm$
		EndIf
		
		If iniLines>500 Then fin=1
		If Eof(quickin) Then fin=1
	Until fin=1
	CloseFile quickin
EndIf
End Function

Function FromINI(value,va$="-1",vb$="-1",vc$="-1",vd$="-1",ve$="-1",vf$="-1",vg$="-1")
Local fout=value
va$=Lower$(Trim$(Replace$(va$," ","")))
vb$=Lower$(Trim$(Replace$(vb$," ","")))
vc$=Lower$(Trim$(Replace$(vc$," ","")))
vd$=Lower$(Trim$(Replace$(vd$," ","")))
ve$=Lower$(Trim$(Replace$(ve$," ","")))
vf$=Lower$(Trim$(Replace$(vf$," ","")))
vg$=Lower$(Trim$(Replace$(vg$," ","")))

For inie=1 To iniLines
	If va$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vb$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vc$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vd$=inicmd[inie] Then fout=Int(iniparm[inie])
	If ve$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vf$=inicmd[inie] Then fout=Int(iniparm[inie])
	If vg$=inicmd[inie] Then fout=Int(iniparm[inie])
Next

Return fout
End Function


Function FromINItxt$(value$,va$="-1",vb$="-1",vc$="-1",vd$="-1",ve$="-1",vf$="-1",vg$="-1")
Local fout$=value
va$=Lower$(Trim$(Replace$(va$," ","")))
vb$=Lower$(Trim$(Replace$(vb$," ","")))
vc$=Lower$(Trim$(Replace$(vc$," ","")))
vd$=Lower$(Trim$(Replace$(vd$," ","")))
ve$=Lower$(Trim$(Replace$(ve$," ","")))
vf$=Lower$(Trim$(Replace$(vf$," ","")))
vg$=Lower$(Trim$(Replace$(vg$," ","")))

For inie=1 To iniLines
	If va$=inicmd[inie] Then fout=iniparm[inie]
	If vb$=inicmd[inie] Then fout=iniparm[inie]
	If vc$=inicmd[inie] Then fout=iniparm[inie]
	If vd$=inicmd[inie] Then fout=iniparm[inie]
	If ve$=inicmd[inie] Then fout=iniparm[inie]
	If vf$=inicmd[inie] Then fout=iniparm[inie]
	If vg$=inicmd[inie] Then fout=iniparm[inie]
Next

Return fout
End Function



Function SplitText$(in$,Split$,e,alsospace=0)

	'Splits text...
	Local out:String=""
	Local start:Int=1
	Local nomore:Int=0
	Local shift:Int
	Local size:Int

	in:String=Trim(in)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Mid$(in$,start,size)
	If nomore=1 Then out$="-+-"
	Return out
End Function

Function IniLeft$(ftxt$)
	Return Upper$(Trim$(splittext$(ftxt$,"=",1,0)))
End Function

Function IniRight$(ftxt$)
	Return Trim$(splittext$(ftxt$,"=",2,0))
End Function


Function Ink(ang#,bright#)
	Local fr#=(150+(Cos(ang)*100.0))*bright
	Local fg#=(150+(Cos(ang+240)*100.0))*bright
	Local fb#=(150+(Cos(ang+120)*100.0))*bright
	
	If fr<0 Then fr=0
	If fr>255 Then fr=255
	If fgr<0 Then fg=0
	If fg>255 Then fg=255
	If fb<0 Then fb=0
	If fb>255 Then fb=255
	SetColor(fr,fg,fb)
End Function


Function ResetDraw()
SetRotation 0
SetAlpha(1)
SetColor(255,255,255)
SetBlend(ALPHABLEND)
End Function

Graphics ScreenWidth,ScreenHeight
Global SpriteX,SpriteY
Global w,h
w=SpriteWidth;h=SpriteHeight
SeedRnd(MilliSecs());For n=0 To 100;r=Rnd(0,10);Next

Repeat

' Reset Ground Settings
SeedRnd(MilliSecs());For e=0 To 10;r=Rnd(0,1);Next
RandSeed=Rand(0,37171650)


GrassColor=Rand(0,360)
GroundColor=(GrassColor+180)+Rand(-40,40)
r=Rand(0,2)
If r=1 Then GroundColor=(GrassColor+120)+Rand(-40,40)
If r=2 Then GroundColor=(GrassColor+240)+Rand(-40,40)
GrassType=Rand(0,1)
BottomType=Rand(0,1)
TopType=Rand(0,1)
GrassTexture=Rand(0,MaxTextures)
GroundTexture=Rand(0,MaxTextures)
SubTexture=Rand(0,MaxTextures);UseSubTexture=Rand(0,1)


GrassThick=Rand(Float(SpriteHeight)*0.15,Float(SpriteHeight)*0.4)
ShadowThick=Rand(Float(SpriteHeight)*0.05,Float(SpriteHeight)*0.25)
HighlightThick=Rnd(Float(SpriteHeight)*0.10,Float(SpriteHeight)*0.45)
HighlightPower=Rnd(0.3,4.0)

DarkenThick=Rnd(Float(SpriteHeight)*0.30,Float(SpriteHeight)*0.65)
DarkenPower=Rnd(1.0,2.0)

DarkDepthGrass=Rnd(0.5,0.8)
DarkDepthGround=Rnd(0.5,0.8)
DarkDepth=DarkDepthGrass


LeftFade=Rnd(0.25,0.5)
RightFade=Rnd(0.25,0.5)


Psychedelia#=Rnd(0,360)

EdgeType=Rand(0,3)
EdgeDistance=Rnd(0.15,0.4)
EdgeType=1

Cls

For SpriteY=0 To SpritesY-1
For SpriteX=0 To SpritesX-1
ResetDraw()
SetViewport(SpriteX*SpriteWidth,SpriteY*SpriteHeight,SpriteWidth,SpriteHeight)
SetOrigin(SpriteX*SpriteWidth,SpriteY*SpriteHeight)
w=SpriteWidth;h=SpriteHeight
SetColor((MaskColor & $FF0000) Shr 16,(MaskColor & $00FF00) Shr 8,(MaskColor & $0000FF))
DrawRect(dx,dy,w,h)

ResetDraw()
Generator(SpriteY,SpriteX)


SetViewport(0,0,ScreenWidth,ScreenHeight)
SetOrigin(0,0)
Flip
Next
Next

outimg=GrabPixmap(0,0,ScreenWidth,ScreenHeight)
For x=0 To ScreenWidth-1
For y=0 To ScreenHeight-1
	argb=ReadPixel(outimg,x,y)
	If (argb & $00FFFFFF)=MaskColor Then argb=$00000000
	WritePixel(outimg,x,y,argb)
Next
Next

If Rescale=0
	SavePixmapPNG(outimg,OutFilename+".png")
EndIf

If Rescale=1
	SavePixmapPNG(outimg,OutFilename+"-hd2.png")
	outimg_2=ResizePixmap(outimg,ScreenWidth/2,ScreenHeight/2)
	SavePixmapPNG(outimg_2,OutFilename+"-hd.png")
	outimg_1=ResizePixmap(outimg,ScreenWidth/4,ScreenHeight/4)
	SavePixmapPNG(outimg_1,OutFilename+".png")
EndIf

If Rescale=2
	SavePixmapPNG(outimg,OutFilename+".png")
	outimg_2=CreatePixmap(ScreenWidth*2,ScreenHeight*2,PF_RGBA8888)
	outimg_4=CreatePixmap(ScreenWidth*4,ScreenHeight*4,PF_RGBA8888)
	
	For x=0 To ScreenWidth-1
	For y=0 To ScreenHeight-1
		argb=ReadPixel(outimg,x,y)
	
		WritePixel(outimg_2,x*2,y*2,argb)
		WritePixel(outimg_2,x*2,y*2+1,argb)
		WritePixel(outimg_2,x*2+1,y*2,argb)
		WritePixel(outimg_2,x*2+1,y*2+1,argb)

		For ex=0 To 3
		For ey=0 To 3
			WritePixel(outimg_4,x*4+ex,y*4+ey,argb)
		Next
		Next
		
	Next
	Next
	
	SavePixmapPNG(outimg_2,OutFilename+"-hd.png")
	SavePixmapPNG(outimg_4,OutFilename+"-hd2.png")
EndIf

SetColor(0,0,0)
SetAlpha(0.5)
DrawText("R to Redraw : Any other key to Quit",6,ScreenHeight-12)
SetColor(255,255,255)
SetAlpha(0.75)
DrawText("R to Redraw : Any other key to Quit",4,ScreenHeight-14)

Flip
WaitKey()
Until Not KeyDown(KEY_R)

' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
' Generator code goes below!
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


Function DarkAt#(ft,fx#,fy#)
fx=(fx*360.0)/SpriteWidth
fy=(fy*90.0)/SpriteHeight

'ft=25

Local dark#=1.0
Select ft
	Case 0
		dark=Sin(fx+fy)
	Case 1
		dark=Sin(fy+(fx*4.0))
	Case 2
		dark=Sin(fx-fy)
	Case 3
		dark=Sin(fy-(fx*4.0))
	Case 4
		dark=Abs(Sin(fx+fy))
	Case 5
		dark=Abs(Sin(fy+(fx*4.0)))
	Case 6
		dark=Abs(Sin(fx-fy))
	Case 7
		dark=Abs(Sin(fy-(fx*4.0)))
	Case 8
		dark=Sin(fx)
	Case 9
		dark=Sin(fy)
	Case 10
		dark=Sin(fx*4.0)
	Case 11
		dark=Sin(fy*4.0)
	Case 12
		dark=Cos(fx)+Sin(fy)
	Case 13
		dark=Cos(fx*4.0)+Sin(fy*4.0)
	Case 14
		dark=Cos(fx)+Sin(fy)
		dark=1.5-dark
	Case 15
		dark=(Cos(fx*4.0)+Sin(fy*4.0))
		dark=1.5-dark
	Case 16
		dark=Cos(fx)>Cos(fy)
	Case 17
		dark=Cos(fx*4.0)>Cos(fy*4.0)
	Case 18
		dark=((fx*4.0)Mod 360)<180
	Case 19
		dark=((((fx*4.0)Mod 360)<180)+(((fy*4.0)Mod 360)<180)) Mod 2
	Case 20
		dark=((((fx*2.0)Mod 360)<180)+(((fy*2.0)Mod 360)<180)) Mod 2
	Case 21
		dark=((((fx)Mod 360)<180)+(((fy)Mod 360)<180)) Mod 2
	Case 22
		dark=Rnd(0,1)
	Case 23
		dark=((fx Mod 180)-(fy Mod 180))
		dark=dark+(((fx+90) Mod 360)-((fy+90) Mod 360))
		dark=dark/1.5
	Case 24
		dark=Sin(((Cos(fx*2.0)+Sin(fy*2.0))*360)+Psychedelia)
	Case 25
		dark=Sin(((Cos(fx/1.0)+Sin(fy/1.0))*180)+Psychedelia)+1.0
		
	Default
		Local fz#,fa,fb,fr,fe
		Local sp=6
		SeedRnd(RandSeed)
		For fe=0 To sp;fr=Rnd(0,1);Next
		Local fs=Rand(1,4)
		If fs=1 Then fz#=90
		If fs=2 Then fz#=11.25
		If fs=3 Then fz#=22.5
		If fs=4 Then fz#=45.0
		fs=Rand(1,4)
		
		SeedRnd((fx/fz)+RandSeed)
		For fe=0 To sp;fr=Rnd(0,1);Next
		fa=Rand(0,1)

		If fs=1 Then fz#=90
		If fs=2 Then fz#=11.25
		If fs=3 Then fz#=22.5
		If fs=4 Then fz#=45.0
		
		SeedRnd((fy/fz)+RandSeed)
		For fe=0 To sp;fr=Rnd(0,1);Next
		fb=Rand(0,1)
		
		dark=fa Or fb

		SeedRnd(RandSeed2);For fe=0 To 64;fr=Rnd(0,1);RandSeed2=(RandSeed2+1) Mod 37171650;Next

		
End Select

If dark>=0.75 Then dark=1
If dark<0.75 Then dark=DarkDepth

Return dark
End Function


Function Crumple(side,fx#,fy#)
	dist#=0
	ang#=Float(fy*90.0)/SpriteHeight
	
	If side=0
		dist#=fx#-(SpriteWidth*EdgeDistance)
		dist=-dist
		If dist<0 Then dist=0
		dist=(dist*dist)/(Float(SpriteHeight)/2.0)
		dist=Cos(ang)*dist
	EndIf
	
	If side=3
		
		dist#=(SpriteWidth-fx#)-(SpriteWidth*EdgeDistance)
		dist=-dist
		If dist<0 Then dist=0
		dist=(dist*dist)/(Float(SpriteHeight)/2.0)
		dist=Cos(ang)*dist
	EndIf

	
	Return fy#+dist#
	
End Function


Function FadeLeftDo#(fx#,fdark#)
Local dist#=(LeftFade*Float(SpriteWidth))

If fx<dist
	Local add#=(1.5-((Float(fx*1.0)/dist)*0.5))
	add=Floor(add*16.0)/16.0
	fdark=fdark*add
EndIf
Return fdark
End Function

Function FadeRightDo#(fx#,fdark#)
fx=SpriteWidth-fx
Local dist#=(RightFade*SpriteWidth)
If fx<dist
	Local add#=(((Float(fx*1.0)/dist)*0.35)+0.65)
	add=Floor(add*16.0)/16.0
	fdark=fdark*add
EndIf
Return fdark
End Function


Function Generator(layer,side)


For x=0 To w
For y=0 To h*4

ty=Float(y)/4.0;If layer=0 Or layer=1 Then ty=Crumple(Side,x,Float(y)/4.0)

t=GroundTexture
DarkDepth=DarkDepthGround

darken#=DarkAt(t,x,y)

If UseSubTexture=1
	dual#=DarkAt(SubTexture,x,y)
	darken=(darken+dual)/2.0
EndIf

If layer=0 Or layer=3	' Darken the Base
If y/4>SpriteHeight-DarkenThick
'	DebugLog y
	uy#=SpriteHeight-(y/4)
	uy=(uy/DarkenThick)
	uy=(uy*DarkenPower)
	If uy=0.25 Then uy=0.25
	If uy>1 Then uy=1
	darken=darken*uy
	darken=Floor(darken*8.0)/8.0
EndIf
EndIf

If side=0 Then darken=FadeLeftDo(x,darken)
If side=3 Then darken=FadeRightDo(x,darken)

Ink(GroundColor,darken)
Plot(x,ty)

Next
Next


' Add Grass
DarkDepth=DarkDepthGrass

If layer=0 Or layer=1
GrassHigh=0

For x=0 To w
If GrassType=1 And (x Mod 4)=0 Then GrassHigh=Rand(-8,8)

For y=0 To (GrassThick+GrassHigh)*4
ty=Float(y)/4.0;If layer=0 Or layer=1 Then ty=Crumple(Side,x,Float(y)/4.0)
t=GrassTexture

	darken#=DarkAt(t,x,y)

If y<HighlightThick Then darken=darken*(Float((HighlightThick+Float(HighlightThick/(HighlightPower))-(y))/Float(HighlightThick/(HighlightPower))))
If darken>1
	darken=Floor(darken*3.0)/3.0
EndIf

	If side=0 Then darken=FadeLeftDo(x,darken)
	If side=3 Then darken=FadeRightDo(x,darken)


	Ink(GrassColor,darken)
	Plot(x,ty)
Next

For e=0 To (ShadowThick-1)*4
	fl#=1.0-(Float(e)/Float(ShadowThick))
	fl=(fl*4)
	fl=Float(Floor(fl))/6.0

	SetAlpha(fl)
	SetColor(0,0,0)
ty=Float(y+e)/4.0;If layer=0 Or layer=1 Then ty=Crumple(Side,x,Float(y+e)/4.0)
	Plot(x,ty)
Next
SetAlpha(1)
Next
	
EndIf





End Function